SystemOrganization addCategory: #'EjerciciosPoo-Distance-BarroumeresLaje'!

Object subclass: #Distance
	instanceVariableNames: 'distanceAmount distanceUnit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Distance-BarroumeresLaje'!

!Distance class methodsFor: 'as yet unclassified' stamp: ''!
of: aDistanceAmount in: aMeasureUnit 
	^ self new amount: aDistanceAmount;
		 unit: aMeasureUnit! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
* anAmount 
	^ Distance of: self amount * anAmount in: self unit! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
+ anotherDistance 
	| normalizedSelf normalizedOther |
	normalizedSelf := self convertTo: MeasureUnit centimeter.
	normalizedOther := anotherDistance convertTo: MeasureUnit centimeter.
	^ Distance of: normalizedSelf amount + normalizedOther amount / self unit ratioFromCentimetre in: self unit! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
- anotherDistance 
	| normalizedSelf normalizedOther |
	normalizedSelf := self convertTo: MeasureUnit centimeter.
	normalizedOther := anotherDistance convertTo: MeasureUnit centimeter.
	^ Distance of: normalizedSelf amount - normalizedOther amount / self unit ratioFromCentimetre in: self unit! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
/ anAmount 
	^ Distance of: self amount / anAmount in: self unit! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
< anotherDistance 
	^ self amount < (anotherDistance convertTo: self unit) amount! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
<= anotherDistance 
	^ self < anotherDistance or: self = anotherDistance! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
= anotherDistance 
	| retVal |
	retVal := false.
	(anotherDistance isKindOf: Distance)
		ifTrue: [retVal := self amount * self unit ratioFromCentimetre = (anotherDistance amount * anotherDistance unit ratioFromCentimetre)].
	^ retVal! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
> anotherDistance 
	^ anotherDistance < self! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
>= anotherDistance 
	^ self > anotherDistance or: self = anotherDistance! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
amount
	^ distanceAmount! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
amount: aDistanceAmount 
	distanceAmount := aDistanceAmount! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
between: aDistance and: anotherDistance 
	^ self <= anotherDistance and: aDistance <= self! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
convertTo: aMeasureUnit 
	^ Distance of: self amount * self unit ratioFromCentimetre / aMeasureUnit ratioFromCentimetre in: aMeasureUnit! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
hash
	^ self! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
max: anotherDistance 
	self > anotherDistance
		ifTrue: [^ self].
	^ anotherDistance! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
min: anotherDistance 
	self < anotherDistance
		ifTrue: [^ self].
	^ anotherDistance! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
negated
	distanceAmount := distanceAmount * -1! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
printOn: aStream 
	aStream nextPutAll: self amount printString.
	aStream nextPutAll: ' '.
	aStream nextPutAll: self unit printString.
	self amount abs > 1
		ifTrue: [aStream nextPutAll: 's']! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
to: anotherDistance 
	^ self
		to: anotherDistance
		by: (Distance of: 1 in: self unit)! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
to: anotherDistance by: aStepDistance 
	^ DistanceInterval
		from: self
		to: anotherDistance
		by: aStepDistance! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
unit
	^ distanceUnit! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
unit: aMeasureUnit 
	distanceUnit := aMeasureUnit! !

Object subclass: #DistanceInterval
	instanceVariableNames: 'distanceFrom distanceTo distanceStep'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Distance-BarroumeresLaje'!

!DistanceInterval class methodsFor: 'as yet unclassified' stamp: ''!
from: aDistance to: anotherDistance by: stepDistance 
	^ self new from: aDistance;
		 to: anotherDistance;
		 by: stepDistance! !

!DistanceInterval methodsFor: 'accessing' stamp: ''!
by
	^ distanceStep! !

!DistanceInterval methodsFor: 'accessing' stamp: ''!
by: aDistance 
	distanceStep := aDistance! !

!DistanceInterval methodsFor: 'accessing' stamp: ''!
do: t1 
	| t2 t3 t4 |
	t3 := 0.
	t4 := self size.
	[t3 < t4]
		whileTrue: [t2 := self from
						+ (Distance of: t3 * self by amount in: self by unit).
			t3 := t3 + 1.
			t1 value: t2]! !

!DistanceInterval methodsFor: 'accessing' stamp: ''!
from
	^ distanceFrom! !

!DistanceInterval methodsFor: 'accessing' stamp: ''!
from: aDistance 
	distanceFrom := aDistance! !

!DistanceInterval methodsFor: 'accessing' stamp: ''!
size
	^ (Interval
		from: (self from convertTo: MeasureUnit centimeter) amount
		to: (self to convertTo: MeasureUnit centimeter) amount
		by: (self by convertTo: MeasureUnit centimeter) amount) size! !

!DistanceInterval methodsFor: 'accessing' stamp: ''!
to
	^ distanceTo! !

!DistanceInterval methodsFor: 'accessing' stamp: ''!
to: aDistance 
	distanceTo := aDistance! !

Object subclass: #MeasureUnit
	instanceVariableNames: 'ratioFromCentimetre unitName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Distance-BarroumeresLaje'!

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: ''!
centimeter
	^ self new ratioFromCentimetre: 1;
		 unitName: 'centimeter'! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: ''!
decameter
	^ self new ratioFromCentimetre: 1000;
		 unitName: 'decameter'! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: ''!
decimeter
	^ self new ratioFromCentimetre: 10;
		 unitName: 'decimeter'! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: ''!
hectometer
	^ self new ratioFromCentimetre: 10000;
		 unitName: 'hectometer'! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: ''!
kilometer
	^ self new ratioFromCentimetre: 100000;
		 unitName: 'kilometer'! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: ''!
meter
	^ self new ratioFromCentimetre: 100;
		 unitName: 'meter'! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: ''!
millimeter
	^ self new ratioFromCentimetre: 0.1;
		 unitName: 'milimeter'! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: ''!
= anotherUnit 
	^ self ratioFromCentimetre = anotherUnit ratioFromCentimetre! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: ''!
printOn: aStream 
	aStream nextPutAll: self unitName! !

!MeasureUnit methodsFor: 'accessing' stamp: ''!
ratioFromCentimetre
	^ ratioFromCentimetre! !

!MeasureUnit methodsFor: 'accessing' stamp: ''!
ratioFromCentimetre: anObject 
	ratioFromCentimetre := anObject! !

!MeasureUnit methodsFor: 'accessing' stamp: ''!
unitName
	^ unitName! !

!MeasureUnit methodsFor: 'accessing' stamp: ''!
unitName: anObject 
	unitName := anObject! !

TestCase subclass: #DistanceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Distance-BarroumeresLaje'!

!DistanceTest methodsFor: 'distance units' stamp: ''!
centimeter
	^ MeasureUnit centimeter! !

!DistanceTest methodsFor: 'distance units' stamp: ''!
decameter
	^ MeasureUnit decameter! !

!DistanceTest methodsFor: 'distance units' stamp: ''!
decimeter
	^ MeasureUnit decimeter! !

!DistanceTest methodsFor: 'distance measures' stamp: ''!
distanceExamples
	| distancesCategory distancesMessageNames |
	distancesCategory := self class organization categoryOfElement: thisContext method selector.
	distancesMessageNames := (self class organization listAtCategoryNamed: distancesCategory)
				reject: [:aMessageName | aMessageName = thisContext method selector].
	^ distancesMessageNames
		collect: [:aMessageName | self perform: aMessageName]! !

!DistanceTest methodsFor: 'distance units' stamp: ''!
distanceUnits
	| unitsCategory unitsMessageNames |
	unitsCategory := self class organization categoryOfElement: thisContext method selector.
	unitsMessageNames := (self class organization listAtCategoryNamed: unitsCategory)
				reject: [:aMessageName | aMessageName = thisContext method selector].
	^ unitsMessageNames
		collect: [:aMessageName | self perform: aMessageName]! !

!DistanceTest methodsFor: 'distance units' stamp: ''!
hectometer
	^ MeasureUnit hectometer! !

!DistanceTest methodsFor: 'distance units' stamp: ''!
kilometer
	^ MeasureUnit kilometer! !

!DistanceTest methodsFor: 'distance units' stamp: ''!
meter
	^ MeasureUnit meter! !

!DistanceTest methodsFor: 'distance units' stamp: ''!
millimeter
	^ MeasureUnit millimeter! !

!DistanceTest methodsFor: 'distance measures' stamp: ''!
minusOneMeter
	^ Distance of: -1 in: MeasureUnit meter! !

!DistanceTest methodsFor: 'distance measures' stamp: ''!
oneCentimeter
	^ Distance of: 1 in: MeasureUnit centimeter! !

!DistanceTest methodsFor: 'distance measures' stamp: ''!
oneHundredCentimeters
	^ Distance of: 100 in: MeasureUnit centimeter! !

!DistanceTest methodsFor: 'distance measures' stamp: ''!
oneMeter
	^ Distance of: 1 in: MeasureUnit meter! !

!DistanceTest methodsFor: '1 - Test equality' stamp: ''!
test01ObjectsRepresentingSameDistanceShouldBeEqual
	self assert: self oneMeter = self oneMeter.
	self assert: self oneHundredCentimeters = self oneHundredCentimeters! !

!DistanceTest methodsFor: '1 - Test equality' stamp: ''!
test02DiferentDistancesShouldNotBeEqual
	self deny: self oneMeter = self twoMeters.
	self deny: self twoMeters = self oneMeter! !

!DistanceTest methodsFor: '1 - Test equality' stamp: ''!
test03SameDistanceExpressWithDifferentUnitsShouldBeEqual
	self assert: self oneMeter = self oneHundredCentimeters.
	self assert: self twoMeters = self twoHundredCentimeters! !

!DistanceTest methodsFor: '1 - Test equality' stamp: ''!
test04EqualsShouldBeCommutative
	self
		assert: (self oneMeter = self oneHundredCentimeters
				and: [self oneHundredCentimeters = self oneMeter]).
	self
		assert: (self twoMeters = self twoHundredCentimeters
				and: [self twoHundredCentimeters = self twoMeters])! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: ''!
test05UnitStringRepresentationShouldBeHumanReadable
	self assert: self meter printString = 'meter'.
	self assert: self centimeter printString = 'centimeter'.
	self assert: self decimeter printString = 'decimeter'.
	self assert: self millimeter printString = 'milimeter'.
	self assert: self decameter printString = 'decameter'.
	self assert: self hectometer printString = 'hectometer'.
	self assert: self kilometer printString = 'kilometer'! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: ''!
test06DistanceStringRepresentationShouldBeHumanReadable
	self assert: self oneMeter printString = '1 meter'.
	self assert: self twoMeters printString = '2 meters'.
	self assert: self oneHundredCentimeters printString = '100 centimeters'! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: ''!
test07aDistanceAmountShouldBeTheExpectedAmount
	self assert: self oneMeter amount = 1.
	self assert: self twoMeters amount = 2.
	self assert: self oneHundredCentimeters amount = 100.
	self assert: self twoHundredCentimeters amount = 200! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: ''!
test07bDistanceUnitShouldBeTheExpectedUnit
	self assert: self oneMeter unit = self meter.
	self assert: self twoMeters unit = self meter.
	self assert: self oneHundredCentimeters unit = self centimeter.
	self assert: self twoHundredCentimeters unit = self centimeter! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: ''!
test07cDifferentDistanceUnitsShouldBeDifferent
	| unitsGroupedByItself |
	unitsGroupedByItself := self distanceUnits
				groupedBy: [:aDistanceUnit | aDistanceUnit].
	self
		assert: (unitsGroupedByItself
				allSatisfy: [:aCollectionOfUnit | aCollectionOfUnit size = 1])! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: ''!
test07dDistancesCanBeConvertedToDifferentUnits
	(Array with: self oneMeter with: self oneHundredCentimeters)
		do: [:aDistance | 
			self assert: (aDistance convertTo: self meter) amount = 1.
			self assert: (aDistance convertTo: self meter) unit = self meter.
			self assert: (aDistance convertTo: self decimeter) amount = 10.
			self assert: (aDistance convertTo: self decimeter) unit = self decimeter.
			self assert: (aDistance convertTo: self centimeter) amount = 100.
			self assert: (aDistance convertTo: self centimeter) unit = self centimeter.
			self assert: (aDistance convertTo: self millimeter) amount = 1000.
			self assert: (aDistance convertTo: self millimeter) unit = self millimeter.
			self assert: (aDistance convertTo: self decameter) amount = (1 / 10).
			self assert: (aDistance convertTo: self decameter) unit = self decameter.
			self assert: (aDistance convertTo: self hectometer) amount = (1 / 100).
			self assert: (aDistance convertTo: self hectometer) unit = self hectometer.
			self assert: (aDistance convertTo: self kilometer) amount = (1 / 1000).
			self assert: (aDistance convertTo: self kilometer) unit = self kilometer]! !

!DistanceTest methodsFor: '3 - Test equality - implementation details' stamp: ''!
test08aComparingDistancesWithOtherObjectsShouldReturnFalse
	self deny: self oneMeter = Object new.
	self deny: Object new = self oneMeter! !

!DistanceTest methodsFor: '3 - Test equality - implementation details' stamp: ''!
test08bDistancesThatAreEqualShouldReturnTheSameHash
	self assert: self oneMeter hash = self oneMeter hash.
	self assert: self oneMeter hash = self oneHundredCentimeters hash! !

!DistanceTest methodsFor: '3 - Test equality - implementation details' stamp: ''!
test08cCopiesOfTheSameDistanceShouldBeEqual
	| originalOneMeter copiedOneMeter |
	originalOneMeter := self oneMeter.
	copiedOneMeter := originalOneMeter copy.
	self deny: originalOneMeter == copiedOneMeter.
	self assert: originalOneMeter = copiedOneMeter! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: ''!
test09AddingDistancesOfSameUnitShouldReturnADistanceRepresentingTheAddingDistances
	self assert: self oneMeter + self oneMeter = self twoMeters! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: ''!
test10AddingDistancesOfDifferentUnitShouldReturnADistanceRepresentingTheAddingDistances
	self assert: self oneMeter + self oneHundredCentimeters = self twoMeters.
	self assert: self oneMeter + self oneHundredCentimeters = self twoHundredCentimeters! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: ''!
test11AddingDistancesIsCommutative
	self assert: self oneMeter + self twoMeters = (self twoMeters + self oneMeter)! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: ''!
test12AddingDistancesIsAssociative
	self assert: self oneMeter + self oneMeter + self twoMeters = (self oneMeter + (self oneMeter + self twoMeters))! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: ''!
test12aAddingDistancesKeepsDistanceInmutability
	| oneMeter |
	oneMeter := self oneMeter.
	oneMeter + oneMeter.
	self assert: oneMeter = self oneMeter! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: ''!
test13aNegatingADistanceNegatesItsAmount
	self assert: self oneMeter negated = self minusOneMeter! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: ''!
test13bNegatingADistanceIsReflective
	self assert: self oneMeter negated negated = self oneMeter! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: ''!
test14SubtractingDistancesOfSameUnitShouldReturnADistanceRepresentingTheSubtractedDistances
	self assert: self twoMeters - self oneMeter = self oneMeter.
	self assert: self oneMeter - self oneMeter = self zeroMeters.
	self assert: self oneMeter - self twoMeters = self oneMeter negated! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: ''!
test15SubtractingDistancesOfDifferentUnitShouldReturnADistanceRepresentingTheSubtractedDistances
	self assert: self twoMeters - self oneHundredCentimeters = self oneMeter.
	self assert: self oneMeter - self oneHundredCentimeters = self zeroMeters.
	self assert: self oneHundredCentimeters - self twoMeters = self oneMeter negated! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: ''!
test16SubtractingDistancesIsAssociative
	self assert: self twoMeters - self oneMeter - self oneMeter = (self twoMeters - (self oneMeter + self oneMeter))! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: ''!
test16aSubtractingDistancesKeepsDistanceInmutability
	| oneMeter |
	oneMeter := self oneMeter.
	oneMeter - oneMeter.
	self assert: oneMeter = self oneMeter! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: ''!
test17aDistancesCanBeMultiplyByAnInteger
	self assert: self oneMeter * 1 = self oneMeter.
	self assert: self oneMeter * 2 = self twoMeters.
	self assert: self oneMeter * 0 = self zeroMeters! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: ''!
test17bDistancesCanBeMultiplyByAFraction
	self assert: (self oneMeter * (2 / 3)) amount = (2 / 3).
	self assert: (self twoMeters * (2 / 3)) amount = (2 * (2 / 3))! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: ''!
test17cDistancesCanBeMultiplyByAFloat
	self assert: (self oneMeter * 2.5) amount = 2.5.
	self assert: (self twoMeters * 2.5) amount = (2 * 2.5)! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: ''!
test18MultiplicationKeepsDistanceInmutability
	| oneMeter |
	oneMeter := self oneMeter.
	oneMeter * 2.
	self assert: oneMeter = self oneMeter! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: ''!
test19aDistancesCanBeDividedByAnInteger
	self assert: self oneMeter / 1 = self oneMeter.
	self assert: self twoMeters / 2 = self oneMeter! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: ''!
test19bDistancesCanBeDividedByAFraction
	self assert: (self twoMeters / (1 / 3)) amount = 6! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: ''!
test19cDistancesCanBeDividedByAFloat
	self assert: (self twoMeters / 2.5) amount = (2 / 2.5)! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: ''!
test20DivisionKeepsDistanceInmutability
	| oneMeter |
	oneMeter := self oneMeter.
	oneMeter / 2.
	self assert: oneMeter = self oneMeter! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: ''!
test21DistancesProvideATotalOrder
	self
		assert: (self distanceExamples
				allSatisfy: [:aDistance | aDistance < (aDistance + self oneMeter)])! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: ''!
test22DistancesCanBeComparedWithGreaterThan
	self
		assert: (self distanceExamples
				allSatisfy: [:aDistance | aDistance + self oneMeter > aDistance])! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: ''!
test23DistancesCanBeComparedWithLessThanOrEqual
	self
		assert: (self distanceExamples
				allSatisfy: [:aDistance | aDistance <= aDistance
						and: [aDistance <= (aDistance + self oneMeter)]])! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: ''!
test24DistancesCanBeComparedWithGreaterThanOrEqual
	self
		assert: (self distanceExamples
				allSatisfy: [:aDistance | aDistance >= aDistance
						and: [aDistance + self oneMeter >= aDistance]])! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: ''!
test25MaxReturnsTheMaximumBetweenTwoDistances
	self assert: (self twoMeters max: self oneMeter)
			= self twoMeters.
	self assert: (self oneMeter max: self twoMeters)
			= self twoMeters.
	self assert: (self twoMeters max: self oneHundredCentimeters)
			= self twoMeters.
	self assert: (self oneHundredCentimeters max: self twoMeters)
			= self twoMeters! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: ''!
test26MinReturnsTheMinimumBetweenTwoDistances
	self assert: (self twoMeters min: self oneMeter)
			= self oneMeter.
	self assert: (self oneMeter min: self twoMeters)
			= self oneMeter.
	self assert: (self twoMeters min: self oneHundredCentimeters)
			= self oneHundredCentimeters.
	self assert: (self oneHundredCentimeters min: self twoMeters)
			= self oneHundredCentimeters! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: ''!
test27BetweenAndReturnsTrueIfADistanceIsBetweenOtherTwoDistances
	self
		assert: (self oneMeter between: self zeroMeters and: self twoMeters).
	self
		assert: (self oneHundredCentimeters between: self zeroMeters and: self twoMeters).
	self
		deny: (self twoMeters between: self zeroMeters and: self oneMeter).
	self
		deny: (self twoHundredCentimeters between: self zeroMeters and: self oneMeter)! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: ''!
test28IntervalOfDistancesCanBeCreatedBecauseTheyDefineATotalOrder
	self assert: (self oneMeter to: self twoMeters) from = self oneMeter.
	self assert: (self oneMeter to: self twoMeters) to = self twoMeters.
	self assert: (self oneMeter to: self twoMeters) by = self oneMeter.
	self assert: (self oneHundredCentimeters to: self twoMeters) from = self oneMeter.
	self assert: (self oneHundredCentimeters to: self twoMeters) to = self twoMeters.
	self assert: (self oneHundredCentimeters to: self twoMeters) by = self oneCentimeter! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: ''!
test29DistanceIntervalStepCanBeAnyDistance
	self assert: (self zeroMeters to: self twoMeters * 2 by: self twoMeters) from = self zeroMeters.
	self assert: (self zeroMeters to: self twoMeters * 2 by: self twoMeters) to = (self twoMeters * 2).
	self assert: (self zeroMeters to: self twoMeters * 2 by: self twoMeters) by = self twoMeters.
	self assert: (self twoMeters * 2 to: self zeroMeters by: self twoMeters negated) from = (self twoMeters * 2).
	self assert: (self twoMeters * 2 to: self zeroMeters by: self twoMeters negated) to = self zeroMeters.
	self assert: (self twoMeters * 2 to: self zeroMeters by: self twoMeters negated) by = self twoMeters negated! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: ''!
test30DistanceIntervalSizeReturnsTheNumberOfDistancesOfTheInterval
	self assert: (self zeroMeters to: self twoMeters * 2) size = 5.
	self assert: (self twoMeters * 2 to: self zeroMeters by: self oneMeter negated) size = 5! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: ''!
test31DistanceIntervalCanBeEnumeratedUsingDo
	| value |
	value := 1.
	(self oneMeter to: self oneMeter * 10)
		do: [:aDistance | 
			self assert: aDistance amount = value.
			value := value + 1].
	self assert: value = 11! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: ''!
test32DistanceIntervalCanBeEnumeratedWithSpecificStep
	| initialDistance byDistance finalDistance value |
	initialDistance := self oneMeter.
	byDistance := self twoMeters.
	finalDistance := initialDistance * 9.
	value := initialDistance amount.
	(initialDistance to: finalDistance by: byDistance)
		do: [:aDistance | 
			self assert: aDistance amount = value.
			value := value + byDistance amount].
	self assert: value = (finalDistance amount + byDistance amount)! !

!DistanceTest methodsFor: 'distance measures' stamp: ''!
twoHundredCentimeters
	^ Distance of: 200 in: MeasureUnit centimeter! !

!DistanceTest methodsFor: 'distance measures' stamp: ''!
twoMeters
	^ Distance of: 2 in: MeasureUnit meter! !

!DistanceTest methodsFor: 'distance measures' stamp: ''!
zeroMeters
	^ Distance of: 0 in: MeasureUnit meter! !

Interval subclass: #IntervalOfDistances
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Distance-BarroumeresLaje'!

!IntervalOfDistances class methodsFor: 'as yet unclassified' stamp: ''!
from: aDistance to: anotherDistance by: stepDistance 
	^ super
		from: (aDistance convertTo: MeasureUnit centimeter) amount
		to: (anotherDistance convertTo: MeasureUnit centimeter) amount
		by: (stepDistance convertTo: MeasureUnit centimeter) amount! !

!IntervalOfDistances methodsFor: 'as yet unclassified' stamp: ''!
amount
	^ self value! !

!IntervalOfDistances methodsFor: 'as yet unclassified' stamp: ''!
by
	^ Distance of: self increment in: MeasureUnit centimeter! !

!IntervalOfDistances methodsFor: 'as yet unclassified' stamp: ''!
do: t1 
	| t2 t3 t4 |
	t3 := 0.
	t4 := self size.
	[t3 < t4]
		whileTrue: [t2 := start + (t3 * step).
			t3 := t3 + 1.
			t1
				value: (Distance of: t2 in: MeasureUnit centimeter)]! !

!IntervalOfDistances methodsFor: 'as yet unclassified' stamp: ''!
from
	^ Distance of: self first in: MeasureUnit centimeter! !

!IntervalOfDistances methodsFor: 'as yet unclassified' stamp: ''!
to
	^ Distance of: self last in: MeasureUnit centimeter! !
